/**************************************************************************
 *   bartw: seek mesage sent to video client
 * 
 *  MCIDELAY.C
 *
 *  MCI OPtibase MPEG Driver
 *
 *  Description:
 *
 *      MCI command procedures for delayed commands.
 *
 ***************************************************************************/

#define  UNICODE
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include "mmddk.h"
#include <stdlib.h>
#include <string.h>
#include "digitalv.h"
#include "mcioptb.h"
#include "common.h"            

#define NO_LENGTH   0xFFFFFFFF              // Invalid length 
                              
// In muldiv.asm 
extern DWORD FAR PASCAL muldiv32(DWORD, DWORD, DWORD);

//
// Forward references to non-exported functions 
//
static DWORD NEAR PASCAL optbMciPlay(int iInst, DWORD dwFlags, LPMCI_DGV_PLAY_PARMS lpPlay);





/****************************************************************************
 * Function: DWORD optbMciPlay - Play.
 *
 * Parameters:
 *
 *      int iInst - Current open instance.
 *
 *      DWORD dwFlags - MCI command flags.
 *
 *      LPMCI_PLAY_PARMS lpPlay - Pointer to MCI parameter block.
 *
 * Returns: an MCI error code.
 *
 *       This function is called in response to the MCI_PLAY
 *       command.
 ***************************************************************************/
static DWORD NEAR PASCAL
optbMciPlay(int iInst, DWORD dwFlags, LPMCI_DGV_PLAY_PARMS lpPlay)
{
    return(optbNotifyReturn(iInst, (HWND) lpPlay->dwCallback, dwFlags, MCI_NOTIFY_SUCCESSFUL, MCIERR_NO_ERROR));
}


/****************************************************************************
 * Function: DWORD optbMciStop - Stop.
 *
 * Parameters:
 *
 *      int iInst - Current open instance.
 *
 *      DWORD dwFlags - MCI command flags.
 *
 *      LPMCI_GENERIC_PARMS lpGeneric - Pointer to MCI parameter block.
 *
 * Returns: an MCI error code.
 *
 *       This function is called in response to the MCI_STOP
 *       command.
 ***************************************************************************/
static DWORD NEAR PASCAL
optbMciStop(int iInst, DWORD dwFlags, LPMCI_GENERIC_PARMS lpGeneric)
{
    return(optbNotifyReturn(iInst, (HWND) lpGeneric->dwCallback, dwFlags, MCI_NOTIFY_SUCCESSFUL, MCIERR_NO_ERROR));
}

/****************************************************************************
 * Function: DWORD optbMciDelayed - Dispatch the delayed (transport) commands.
 *
 * Parameters:
 *
 *      WORD  wDeviceID - MCI device ID.
 *
 *      WORD  wMessage  - MCI command.
 *
 *      DWORD dwParam1  - MCI command flags.
 *
 *      DWORD dwParam2  - Pointer to MCI parameter block.
 *
 * Returns: an MCI error code.
 *
 *       This function is called by optbMciProc which is called by
 *        DriverProc() to process all MCI commands.
 *
 ***************************************************************************/
DWORD FAR PASCAL
optbMciDelayed(WORD wDeviceID, WORD wMessage, DWORD dwParam1, DWORD dwParam2)
{
    DWORD           dwRes;
    int i;
    int   iInst = (int)(UINT)mciGetDriverData(wDeviceID); 
    DWORD lParam;

    if (iInst == -1)
        return (MCIERR_INVALID_DEVICE_ID);      
 
    switch (wMessage)
    {     
        case MCI_PLAY:
        	//MessageBox(NULL,"mci_play",NULL, MB_ICONEXCLAMATION); 
        	if (dwParam1 & MCI_FROM) {
        		pinst[iInst].mcimode = MCI_MODE_PLAY;
        		dwRes = MCIERR_NO_ERROR; 
        	
        		optbMciTimeFormatToViscaData(iInst, TRUE,
                    (DWORD)(((LPMCI_DGV_PLAY_PARMS)dwParam2)->dwFrom),
                    pinst[iInst].position, VISCADATAHMSF);  
                optbDataToMiliseconds(iInst, TRUE, pinst[iInst].position,&slidertime);    
                //_DPF7(DBG_MEM,"mci_play from: %lu",  slidertime);
	            /*{                                                                                   
	               	//Special case handling
	            	//We need to get the slider position in moment of seeking in order to
	            	//estimate the position of the driver in case of values more than 32K of frames.
	                //Optibase decoder cannot handle slider position bigger than 32K frames
	                //The solution is an estimation of slider position from movie frame rate and real time difference
	                DWORD slidertime;
	            	optbDataToMiliseconds(iInst, TRUE, pinst[iInst].position,
	                                                     &slidertime);  
	                //_DPF7(DBG_MEM,"seek to %ld ms",slidertime);
					                                                   
	                if (slidertime + 5000 > 32768 / 30 * 1000)  //(32K frames / frames per second * miliseconds per second)
	                {
		                  slider_pos_big = TRUE;   
		                  //MessageBox(NULL,"slider_pos_big!!!",NULL, MB_ICONEXCLAMATION); 
		            }
		            else
		            	  slider_pos_big = FALSE;  
	            	pinst[iInst].playstartpos = slidertime;
	            	pinst[iInst].playstarttime = GetTickCount();
	            }*/                
            	optbDataToMciTimeFormatEx(iInst, TRUE, pinst[iInst].position, &lParam, MCI_FORMAT_FRAMES);
	        	if (find_window() == TRUE) {
		        	for(i=0;i<3;i++)		           
		            	if(PostMessage(hWndClient,VODMCIPlayFrom,0, lParam))
		            	{
		            		//MessageBox(NULL,"stopaaa!!!",NULL, MB_ICONEXCLAMATION);  
		            		break;
		                }   
		            if (i==3) MessageBox(NULL,"VODMCIPlayFrom not sent!!!",NULL, MB_ICONEXCLAMATION); 
		        }
        	}   
        	else
        	{
	            dwRes = optbMciPlay(iInst, dwParam1, (LPMCI_DGV_PLAY_PARMS)dwParam2);
	            pinst[iInst].mcimode = MCI_MODE_PLAY;
	            
	            if (find_window() == TRUE) {
		            for(i=0;i<3;i++)
		            	//if(PostAppMessage(pinst[iInst].hClientApp,VODMCIPaused,0,0L))   
		            	if(PostMessage(hWndClient,VODMCIResumed,0,0L))
		            	{
		            		//MessageBox(NULL,"stopaaa!!!",NULL, MB_ICONEXCLAMATION);  
		            		break;
		                }        
		            if (i==3) MessageBox(NULL,"VODMCIResumed not sent!!!",NULL, MB_ICONEXCLAMATION);  
		        }     
		    }
            
            optbDataToMiliseconds(iInst, TRUE, pinst[iInst].position, &(pinst[iInst].playstartpos));
            pinst[iInst].playstarttime = GetTickCount(); 
            break;     
        case MCI_SEEK: 
        	//MessageBox(NULL,"Seek seek seek seek!!!",NULL, MB_OK|MB_ICONEXCLAMATION); 
        	pinst[iInst].mcimode = MCI_MODE_SEEK; 
        	dwRes = MCIERR_NO_ERROR; 
        	
        	optbMciTimeFormatToViscaData(iInst, TRUE,
                    (DWORD)(((LPMCI_SEEK_PARMS)dwParam2)->dwTo),
                    pinst[iInst].position, VISCADATAHMSF);
            optbDataToMiliseconds(iInst, TRUE, pinst[iInst].position,&slidertime);   
            /*{                                                                                   
               	//Special case handling
            	//We need to get the slider position in moment of seeking in order to
            	//estimate the position of the driver in case of values more than 32K of frames.
                //Optibase decoder cannot handle slider position bigger than 32K frames
                //The solution is an estimation of slider position from movie frame rate and real time difference
                DWORD slidertime;
            	optbDataToMiliseconds(iInst, TRUE, pinst[iInst].position,
                                                     &slidertime);  
                _DPF7(DBG_MEM,"seek to %ld ms",slidertime);
				                                                   
                if (slidertime + 5000 > 32768 / 30 * 1000)  //(32K frames / frames per second * miliseconds per second)
                {
	                  slider_pos_big = TRUE;   
	                  MessageBox(NULL,"slider_pos_big!!!",NULL, MB_ICONEXCLAMATION); 
	            }
	            else
	            	  slider_pos_big = FALSE;  
            	pinst[iInst].playstartpos = slidertime;
            	pinst[iInst].playstarttime = GetTickCount();
            }  */
            optbDataToMciTimeFormatEx(iInst, TRUE, pinst[iInst].position, &lParam, MCI_FORMAT_FRAMES);
        	if (find_window() == TRUE) {
	        	for(i=0;i<3;i++)
	            	//if(PostAppMessage(pinst[iInst].hClientApp,VODMCIPaused,0,0L))   
	            	if(PostMessage(hWndClient,VODMCISeekTo,0, lParam))
	            	{
	            		//MessageBox(NULL,"stopaaa!!!",NULL, MB_ICONEXCLAMATION);  
	            		break;
	                }   
	            if (i==3) MessageBox(NULL,"VODMCISeekTo not sent!!!",NULL, MB_ICONEXCLAMATION); 
	        }
            break;

        case MCI_PAUSE:
            //MessageBox(NULL,"Pause pause pause pause!!!",NULL, MB_OK|MB_ICONEXCLAMATION);
            pinst[iInst].mcimode = MCI_MODE_PAUSE; 
            dwRes = MCIERR_NO_ERROR; 
            if (find_window() == TRUE) {
	            for(i=0;i<3;i++)
	            	//if(PostAppMessage(pinst[iInst].hClientApp,VODMCIPaused,0,0L))   
	            	if(PostMessage(hWndClient,VODMCIPaused,0,0L))
	            	{
	            		//MessageBox(NULL,"stopaaa!!!",NULL, MB_ICONEXCLAMATION);  
	            		break;
	                }
	            if (i==3) MessageBox(NULL,"VODMCIPaused not sent!!!",NULL, MB_ICONEXCLAMATION); 
	        }
            break; 
             
        case MCI_RESUME: 
        	//MessageBox(NULL,"Resume resume!!!",NULL, MB_OK|MB_ICONEXCLAMATION); 
        	pinst[iInst].mcimode = MCI_MODE_PLAY; 

        	optbDataToMiliseconds(iInst, TRUE, pinst[iInst].position, &(pinst[iInst].playstartpos));
            pinst[iInst].playstarttime = GetTickCount();
                                               
        	dwRes = MCIERR_NO_ERROR;
        	if (find_window() == TRUE) {
	        	for(i=0;i<3;i++)
	            	//if(PostAppMessage(pinst[iInst].hClientApp,VODMCIPaused,0,0L))   
	            	if(PostMessage(hWndClient,VODMCIResumed,0,0L))
	            	{
	            		//MessageBox(NULL,"stopaaa!!!",NULL, MB_ICONEXCLAMATION);  
	            		break;
	                }
	            if (i==3) MessageBox(NULL,"VODMCIResumed not sent!!!",NULL, MB_ICONEXCLAMATION); 	 
	        }
            //dwRes = optbMciResume(iInst, dwParam1, (LPMCI_GENERIC_PARMS)dwParam2);
            break;

        case MCI_STOP:
            dwRes = optbMciStop(iInst, dwParam1, (LPMCI_GENERIC_PARMS)dwParam2); 
            pinst[iInst].mcimode = MCI_MODE_STOP; 
            if (find_window() == TRUE) {
	            for(i=0;i<3;i++)
	            	//if(PostAppMessage(pinst[iInst].hClientApp,VODMCIPaused,0,0L))   
	            	if(PostMessage(hWndClient,VODMCIPaused,0,0L))
	            	{
	            		//MessageBox(NULL,"stopaaa!!!",NULL, MB_ICONEXCLAMATION);  
	            		break;
	                }
	            if (i==3) MessageBox(NULL,"VODMCIPaused not sent!!!",NULL, MB_ICONEXCLAMATION); 
	        }
            //MessageBox(NULL,"Msg Stop posted",NULL, MB_ICONEXCLAMATION); 
            break;
    }

    return dwRes;
}

