/**************************************************************************
 *
 *  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 *  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
 *  PURPOSE.
 *
 *  Copyright (c) 1992, 1993  Microsoft Corporation.  All Rights Reserved.
 *
 *  MCIVISCA.H
 *
 *  MCI ViSCA Device Driver
 *
 *  Description:
 *
 *      Driver constants, macros, structures, and globals
 *
 ***************************************************************************/
 
//bartw: includes for video server 
#include "winsock.h" 
#include "pcmtn.h"
//#include "vclient.h"
#include "vod.h" 

HWND hWndClient;	//for sending messages to video client 
HANDLE driver_handle;  //for receiving messages from video client
char frs_file_name[128];   
DWORD slidertime; //to fix Optibase decoder bug
            
//some defines stolen from visca header file  
#define VISCADATAHMS                (BYTE)0x12
#define VISCADATAHMSF               (BYTE)0x13
/* defines to convert to and from binary coded decimal */
#define FROMBCD(b)                  (UINT)(10 * ((BYTE)(b) >> 4) + ((BYTE)(b) & 0x0F))
#define TOBCD(n)                    (BYTE)((((UINT)(n) / 10) << 4) + ((UINT)(n) % 10))   
#define VISCAHOURS(lp)              FROMBCD(((BYTE FAR *)(lp))[1])
#define VISCAMINUTES(lp)            FROMBCD(((BYTE FAR *)(lp))[2])
#define VISCASECONDS(lp)            FROMBCD(((BYTE FAR *)(lp))[3])
#define VISCAFRAMES(lp)             FROMBCD(((BYTE FAR *)(lp))[4])


#ifndef RC_INVOKED

#define MCIERR_NO_ERROR MMSYSERR_NOERROR

#define MAX_INSTANCES   10 //bart: it was 100

//
// This structure is free-floating, and is allocated
// for every open instance of the driver (with open vcr alias a)
//
typedef struct tagOpenInstance {
    BOOL                    fInUse;
 
    UINT                    uDeviceID;      // MCI Device ID

    DWORD                   dwTimeFormat;   // Time format      
    DWORD                   dwCounterFormat;// Counter format 

    DWORD					playstartpos;
    DWORD					playstarttime; 
    WORD					mcimode;
    UINT					hClientApp;
    BYTE					hostname[50];
    BYTE					filename[100];
    BYTE					url[100];
    DWORD					offset;     //in bytes
    DWORD					length;     //in current MCI time format
    BYTE					position[20];        //in ViscaDATA format
    //MP_INIT_STRUCT 			InitStruct;
    
} OpenInstance, *POpenInstance;



//
// The only globals.
//
extern POpenInstance pinst;                     // Pointer to use. (For both versions) NT it's per-instance.

// defines for reading and writing configuration info 
#define MAX_INI_LENGTH  128                    // maximum length of an INI entry  

//
// Function prototypes.
//
// in mcioptb.c
extern int  FAR  PASCAL optbInstanceCreate(UINT uDeviceID);
extern void FAR  PASCAL optbInstanceDestroy(int iInst);
extern int              MemAllocInstance(void);
extern BOOL             MemFreeInstance(int iInstTemp);

// in mcicmds.c              
extern BOOL FAR PASCAL find_window_kill(void);
extern BOOL FAR PASCAL find_window(void);
extern DWORD FAR PASCAL from_frame_to_offset(int iInst, DWORD lParam);
extern UINT FAR PASCAL optbDataPosition(char FAR *lpstrData,unsigned char bTimeFormat,unsigned char bHours,unsigned char bMinutes,unsigned char bSeconds,unsigned char bFrames);//bartw: added from viscamsg
extern DWORD FAR PASCAL optbDataToMciTimeFormat(int iInst, BOOL fTimecode, LPSTR lpstrData, DWORD FAR *lpdwTime);
extern DWORD FAR PASCAL optbDataToMciTimeFormatEx(int iInst, BOOL fTimecode, LPSTR lpstrData, DWORD FAR *lpdwTime, DWORD mciTimeFormat);
extern DWORD FAR PASCAL optbDataToMiliseconds(int iInst, BOOL fTimecode, LPSTR lpstrData, DWORD FAR *lpdwTime);
extern DWORD FAR PASCAL optbMciWindow(int iInst, DWORD dwFlags, LPMCI_DGV_WINDOW_PARMS dwParam2);
extern DWORD FAR PASCAL optbMciProc(WORD wDeviceID, WORD wMessage, DWORD dwParam1, DWORD dwParam2);
extern DWORD FAR PASCAL optbNotifyReturn(int iInst, HWND hwndNotify, DWORD dwFlags, UINT uNotifyMsg, DWORD dwReturnMsg);
extern DWORD FAR PASCAL optbMciStatus(int iInst, DWORD dwFlags, LPMCI_DGV_STATUS_PARMS lpStatus);
extern DWORD FAR PASCAL optbMciTimeFormatToViscaData(int iInst, BOOL fTimecode, DWORD dwTime, LPSTR lpstrData, BYTE bDataFormat); 
extern DWORD FAR PASCAL optbMilisecondsToViscaData(int iInst, BOOL fTimecode, DWORD dwTime, LPSTR lpstrData, BYTE bDataFormat);


// in mcidelay.c
extern DWORD FAR PASCAL optbMciDelayed(WORD wDeviceID, WORD wMessage, DWORD dwParam1, DWORD dwParam2);

#endif /* NOT RC_INVOKED */ 

// define string resource constants 
#define IDS_TABLE_NAME                      0
#define IDS_VERSION                         1
#define IDS_INIFILE                         2
#define IDS_VERSIONNAME                     3

#define IDS_COM1                            4
#define IDS_COM2                            5
#define IDS_COM3                            6
#define IDS_COM4                            7
#define IDS_COM5                            8

#define IDS_CONFIG_ERR_ILLEGALNAME          40
#define IDS_CONFIG_ERR_REPEATNAME           41
#define IDS_CONFIG_WARN_LASTVCR             42
#define IDS_CONFIG_ERR                      43
#define IDS_CONFIG_WARN                     44

#define IDS_DEFAULT_INFO_PRODUCT            10
#define IDS_VENDORID1_BASE                  18
#define IDS_MODELID2_BASE                   26

