/* 
Author: Bartlomiej Winnowicz
------

Filename: optbatch.c
--------


Input Parameters:
---------------- 
1)metadata filename

Function
--------  
1)reusability feature of Video Client.
Simplest approach: 	just killing old Media Player and Video Client apps and loading new ones.

*/
#include<windows.h> 
#include<string.h> 
#include "vod.h"

HWND mp_window, vc_window;
char metafilename[128];
 
int findwindows(void)
{       
	int winbitnum=0;
	if ( (mp_window = FindWindow("MPlayer",NULL))!=NULL ) {
		winbitnum+=2;
		//MessageBox(NULL,"MP found",NULL, MB_OK);
	}
	
	if ( (vc_window = FindWindow("Video Client",NULL))!=NULL ) {
		winbitnum++;
		//MessageBox(NULL,"VC found",NULL, MB_OK);
	}
	
	return winbitnum;	
}                          

void openwindows(LPSTR lpszCmdLine)
{                        
	//HWND tv_window;
	
	GetWindowsDirectory((LPSTR)metafilename,200);
    _fstrcat((LPSTR)metafilename,"\\mplayer.exe ");
    _fstrcat((LPSTR)metafilename, lpszCmdLine);
    if ( WinExec((LPSTR)metafilename,SW_SHOWNORMAL) < 32) {
    	 MessageBox(NULL,"Error in WinExec (Media Player)",NULL, MB_OK);	 
    	 //exit()???
    }                                                                   
    
    //TV500 window show - sorry, it doesn't seem to work  
    //if ( (tv_window = FindWindow("PXTV_R",NULL))!=NULL ) {    	
	//	MessageBox(NULL,"TV500 found",NULL, MB_OK);
	//	PostMessage(tv_window,WM_MOUSEACTIVATE,(WORD)tv_window,MAKELONG(1,WM_LBUTTONDOWN));
	//}
}
 
void PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{                
	DWORD start,end;
	
	switch(findwindows())
	{
		case 2+1: //both old apps exist, kill them and launch new ones
			PostMessage(mp_window, WM_CLOSE, 0, 0L);
			PostMessage(vc_window, VODMCIKill, 0, 0L);	   
			
			start = GetTickCount();
			do 
			{
				Yield();
				end = GetTickCount();
			}            
			while (end-start<1000);
                                     
			if (findwindows()==0)                                     
				openwindows(lpszCmdLine);
			else
				MessageBox(NULL,"Error: Couldn't close old apps. Restart Windows",NULL, MB_OK);				
		break;
		case 0+0:  //no old apps, just start new ones
		    openwindows(lpszCmdLine);			
		break; 
		case 2+0:	//old Media Player used by another driver    
			MessageBox(NULL,"Error: Media Player used by another driver. Close it first.",NULL, MB_OK);
		break; 
        case 0+1:	//wierd: old Video Client working without Media Player. Kill it and start both apps
        	MessageBox(NULL,"Warning: Old Video Client working without Media Player. Trying to kill it",NULL, MB_OK);	
        	
        	PostMessage(vc_window, VODMCIKill, 0, 0L);

        	start = GetTickCount();
			do 
			{
				Yield();
				end = GetTickCount();
			}            
			while (end-start<1000);
			
			if (findwindows()==0)                                     
				openwindows(lpszCmdLine);
			else
				MessageBox(NULL,"Error: Couldn't close old apps. Restart Windows",NULL, MB_OK);	 
		break; 
		default:
			MessageBox(NULL,"Error: invalid case in switch(findwindows()) statement",NULL, MB_OK);	
		break; 
	}
}