/* 
Author: Bartlomiej Winnowicz
------

Filename: optbseek.c
--------


Input Parameters:
---------------- 
1)metadata filename - one line file consisting of random access file offset

Function
--------  
1)sends Seek message to Video Client app                                                                       

Remarks
------- 
Used in VOD NPAC architecture.
It enables seeking in Video Client from Netscape page.
The metadata file is created by CGI on Web server site. 
Another approach is to build netscape plug-in or java applet (doesn't require Web server).

*/
#include<windows.h>
#include<stdlib.h> 
#include<stdio.h>   
#include<string.h>
#include "..\mcioptb\vod.h"
   
void PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{  
    HWND vc_window;  
    char metafilename[128];
    FILE * metafile;
    char offset_s[50];
    DWORD offset;  
    
    _fstrcpy((LPSTR)metafilename,lpszCmdLine);
    
    metafile = fopen(metafilename,"r");
    
    if (fscanf(metafile,"%s\n",offset_s) == 0) {
  		MessageBox(NULL, "Error in fscanf(offset)", NULL, MB_OK); 
  		fclose(metafile);
  		return;
  	} 
	offset = atol(offset_s); 
  	 
	fclose(metafile);                
	
	if ( (vc_window = FindWindow("Video Client",NULL))==NULL ) {
		MessageBox(NULL,"Error: Video Client not found",NULL, MB_OK);
	}
	else {
		PostMessage(vc_window, VODMCIPlayFrom, 0, offset);
	}
		
}
